#pragma once

#include "Tour.h"
#include <string>

class Observer; 

class TSPalgorithm
{
public:
	TSPalgorithm(void);
	~TSPalgorithm(void);

	void Initialize( const int& iterations,
					 CoordMatrix* mat,
					 const float& temp,
					 const float& cool );

	void Run();		
	int  GetTourCity( const int& index );

	void AddObserver( Observer* ob );  
    void Notify( const int& dist, const int& iter );  

	bool Accept( const double& new_dist,
				 const double& old_dist );

private:

	void Rotate( const int& iter );
	void Reverse( const int& iter );
	void TwoOpt( const int& iter );
	void SwapRandomPair(const int& iter );
	void RepairAllPairs();
	void ThreeOpt( const int& iter );

private:
	Tour tour;
	int iterations;
	float temperature;
	float cooling_rate;
	std::vector<Observer*> ob_set; 
	int size;
};

class Observer  
{  
public:  
    virtual void UpdateDisplay( const int& dist, const int& iter ) = 0;  
};  