
// Two-OptDlg.h : header file
//

#pragma once
#include "TSPalgorithm.h"
#include "CoordMatrix.h"
#include "afxwin.h"


// CTwoOptDlg dialog
class CTwoOptDlg : public CDialogEx, Observer
{
// Construction
public:
	CTwoOptDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_TWOOPT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	void Init( TSPalgorithm* tsp );  
    void UpdateDisplay( const int& dist, const int& iter );  



// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OpenTestProblem();
	afx_msg void RunAlgorithm();

private:
	TSPalgorithm alg;
	CoordMatrix mat;
	bool hasRun;

	int cc1, cc2;
	int xc1, xc2;
	int yc1, yc2;
	float xn1, xn2;
	float yn1, yn2;
	int xcoord1, xcoord2;
	int ycoord1, ycoord2;
	int x1, y1;
	int count;
	CStatic distText;
	CStatic iterText;
	
	LOGFONT lf;
	CFont font;
};
